import java.io.*;
import java.util.*;

class Scanner {
    private LineNumberReader sourceFile = null;
    private String curFileName;
    private ArrayList<Token> curLineTokens = new ArrayList<>();

    Scanner(String fileName) {
	curFileName = fileName;
	try {
	    sourceFile = new LineNumberReader(
			    new InputStreamReader(
				new FileInputStream(fileName),
				"UTF-8"));
	} catch (IOException e) {}
    }

    public Token curToken() {
	while (curLineTokens.isEmpty()) {
	    readNextLine();
	}
	return curLineTokens.get(0);
    }

    void readNextToken() {
	if (! curLineTokens.isEmpty())
	    curLineTokens.remove(0);
    }

    private void readNextLine() {
	curLineTokens.clear();

	// Read the next line:
	String line = null;
	try {
	    line = sourceFile.readLine();
	    if (line == null) {
		sourceFile.close();  sourceFile = null;
		line = "";
	    }
	} catch (IOException e) {}

	// Were there any more lines to read?
	if (sourceFile == null) {
	    curLineTokens.add(new Token(TokenKind.eofToken));
	}

	// Find all the tokens:
	int pos = 0;
	while (pos < line.length()) {
	    char c = line.charAt(pos++);

	    if (isDigit(c)) {
		curLineTokens.add(new Token(Integer.parseInt(""+c)));
	    } else if (c == '+') {
		curLineTokens.add(new Token(TokenKind.addToken));
	    } else if (c == '-') {
		curLineTokens.add(new Token(TokenKind.subtractToken));
	    } else if (c == '*') {
		curLineTokens.add(new Token(TokenKind.multiplyToken));
	    } if (c == '/') {
		curLineTokens.add(new Token(TokenKind.divideToken));
	    } else if (c == '(') {
		curLineTokens.add(new Token(TokenKind.leftParToken));
	    } else if (c == ')') {
		curLineTokens.add(new Token(TokenKind.rightParToken));
	    }
	}
	for (Token t: curLineTokens)
	    System.out.println("E scanner: Read a " + t);
    }

    private boolean isDigit(char c) {
	return '0'<=c && c<='9';
    }
}
